(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ReduxFormValidators"] = factory();
	else
		root["ReduxFormValidators"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 2);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEFAULT_OPTIONS = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.regFormat = regFormat;
exports.prepare = prepare;
exports.trunc = trunc;
exports.isNumber = isNumber;
exports.formatMsg = formatMsg;
exports.toObjectMsg = toObjectMsg;
exports.addMsgValues = addMsgValues;
exports.memoize = memoize;

var _format = __webpack_require__(3);

var _format2 = _interopRequireDefault(_format);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_OPTIONS = exports.DEFAULT_OPTIONS = {
  allowBlank: false,
  urlProtocols: ['http', 'https'],
  dateFormat: 'yyyy-mm-dd', // ISO
  dateYmd: 'ymd',
  accept: ['1', 'true'],
  caseSensitive: true // confirmation, inclusion, exclusion
};

function regFormat(options, reg, messageId) {
  options.msg = options.msg || options.message || messageId;
  options.with = reg;
  return (0, _format2.default)(options);
}

function prepare(ifCond, unlessCond, allowBlank, func) {
  return function () {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var allValues = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    value = '' + value;

    if ((null != allowBlank ? allowBlank : DEFAULT_OPTIONS.allowBlank) && !value.trim()) {
      return;
    }
    if (('function' !== typeof ifCond || ifCond(allValues, value)) && ('function' !== typeof unlessCond || !unlessCond(allValues, value))) {
      return func(value, allValues);
    }
  };
}

function trunc(num) {
  return Math.trunc ? Math.trunc(num) : num < 0 ? Math.ceil(num) : Math.floor(num);
}

function isNumber(num) {
  return !isNaN(num) && '' !== ('' + num).trim();
}

var pluralRules = {
  0: /zero\s*\{(.*?)\}/,
  1: /one\s*\{(.*?)\}/,
  other: /other\s*\{(.*?)\}/
};

var TEMPLATE_REG = /\{([^{}]*\{[^{}]*\}[^{}]*)+\}|\{(.*?)\}/g;

function formatMsg(msg) {
  if (msg.props) {
    msg = msg.props;
  }
  var text = msg.defaultMessage || msg.id;
  return ((!msg.values ? text : text) || '').replace(TEMPLATE_REG, function (content) {
    var parts = content.slice(1, -1).split(',');
    var count = msg.values[parts[0]];
    if (parts.length <= 2) {
      return null == count ? '' : count;
    }
    var plural = parts[2].trim();
    var rules = pluralRules[+count];
    var result = void 0;
    if (rules && (result = plural.match(rules))) {
      return result[1];
    }
    return (plural.match(pluralRules.other) || [])[1] || '';
  });
}

function toObjectMsg(msg) {
  if (null == msg) return null;
  return isObject(msg) ? msg : { id: msg, defaultMessage: msg };
}

function addMsgValues(msg, values) {
  return Object.assign({}, msg, { values: values });
}

function memoize(func) {
  if (!func.cache) {
    func.cache = {};
  }
  return function (options) {
    var key = stringify(options);
    return HAS_PROP.call(func.cache, key) ? func.cache[key] : func.cache[key] = func(options);
  };
}

// private
var HAS_PROP = {}.hasOwnProperty;
var TO_STRING = {}.toString;

function stringify(options) {
  var arr = [];
  var value = void 0;
  for (var k in options) {
    if (HAS_PROP.call(options, k)) {
      value = options[k];
      arr.push(k, isReactElement(value) ? stringify(value.props) : isObject(value) ? stringify(value) : value.toString());
    }
  }
  return JSON.stringify(arr);
}

function isReactElement(object) {
  return (typeof object === 'undefined' ? 'undefined' : _typeof(object)) === 'object' && object !== null && '$$typeof' in object;
}

function isObject(obj) {
  return 'object' === (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) && '[object Object]' === TO_STRING.call(obj) && null !== obj;
}

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reduxFormValidators = __webpack_require__(6);

var messages = (0, _reduxFormValidators.defineMessages)({
  absence: {
    id: "form.errors.absence",
    defaultMessage: "must be blank"
  },
  acceptance: {
    id: "form.errors.acceptance",
    defaultMessage: "must be accepted"
  },
  confirmation: {
    id: "form.errors.confirmation",
    defaultMessage: "doesn't match `{fieldLabel}`"
  },
  dateFormat: {
    id: "form.errors.dateFormat",
    defaultMessage: "expected format: {format}"
  },
  dateInvalid: {
    id: "form.errors.dateInvalid",
    defaultMessage: "is not a valid date"
  },
  dateRange: {
    id: "form.errors.dateRange",
    defaultMessage: "shoud be {op} {date}"
  },
  email: {
    id: "form.errors.email",
    defaultMessage: "is not a valid email"
  },
  equalTo: {
    id: "form.errors.equalTo",
    defaultMessage: "must be equal to {count, number}"
  },
  even: {
    id: "form.errors.even",
    defaultMessage: "must be even"
  },
  exclusion: {
    id: "form.errors.exclusion",
    defaultMessage: "is reserved"
  },
  greaterThan: {
    id: "form.errors.greaterThan",
    defaultMessage: "must be greater than {count, number}"
  },
  greaterThanOrEqualTo: {
    id: "form.errors.greaterThanOrEqualTo",
    defaultMessage: "must be greater than or equal to {count, number}"
  },
  inclusion: {
    id: "form.errors.inclusion",
    defaultMessage: "is not included in the list"
  },
  invalid: {
    id: "form.errors.invalid",
    defaultMessage: "is invalid"
  },
  lessThan: {
    id: "form.errors.lessThan",
    defaultMessage: "must be less than {count, number}"
  },
  lessThanOrEqualTo: {
    id: "form.errors.lessThanOrEqualTo",
    defaultMessage: "must be less than or equal to {count, number}"
  },
  notANumber: {
    id: "form.errors.notANumber",
    defaultMessage: "is not a number"
  },
  odd: {
    id: "form.errors.odd",
    defaultMessage: "must be odd"
  },
  otherThan: {
    id: "form.errors.otherThan",
    defaultMessage: "must be other than {count, number}"
  },
  presence: {
    id: "form.errors.presence",
    defaultMessage: "is required"
  },
  tooLong: {
    id: "form.errors.tooLong",
    defaultMessage: "is too long (maximum is {count, number} {count, plural, one {character} other {characters}})"
  },
  tooShort: {
    id: "form.errors.tooShort",
    defaultMessage: "is too short (minimum is {count, number} {count, plural, one {character} other {characters}})"
  },
  url: {
    id: "form.errors.url",
    defaultMessage: "is not a valid URL"
  },
  wrongLength: {
    id: "form.errors.wrongLength",
    defaultMessage: "is the wrong length (should be {count, number} {count, plural, one {character} other {characters}})"
  }
});

exports.default = messages;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.url = exports.required = exports.presence = exports.numericality = exports.length = exports.inclusion = exports.format = exports.exclusion = exports.email = exports.date = exports.confirmation = exports.addValidator = exports.acceptance = exports.absence = undefined;

var _absence = __webpack_require__(5);

var _absence2 = _interopRequireDefault(_absence);

var _acceptance = __webpack_require__(7);

var _acceptance2 = _interopRequireDefault(_acceptance);

var _addValidator = __webpack_require__(8);

var _addValidator2 = _interopRequireDefault(_addValidator);

var _confirmation = __webpack_require__(9);

var _confirmation2 = _interopRequireDefault(_confirmation);

var _date = __webpack_require__(10);

var _date2 = _interopRequireDefault(_date);

var _email = __webpack_require__(11);

var _email2 = _interopRequireDefault(_email);

var _format = __webpack_require__(3);

var _format2 = _interopRequireDefault(_format);

var _inclusion = __webpack_require__(4);

var _inclusion2 = _interopRequireDefault(_inclusion);

var _exclusion = __webpack_require__(12);

var _exclusion2 = _interopRequireDefault(_exclusion);

var _length = __webpack_require__(13);

var _length2 = _interopRequireDefault(_length);

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _numericality = __webpack_require__(14);

var _numericality2 = _interopRequireDefault(_numericality);

var _presence = __webpack_require__(15);

var _presence2 = _interopRequireDefault(_presence);

var _url = __webpack_require__(16);

var _url2 = _interopRequireDefault(_url);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var required = _presence2.default; // alias

exports.default = {
  formatMessage: _helpers.formatMsg,
  defaultOptions: _helpers.DEFAULT_OPTIONS,
  messages: _messages2.default
};
exports.absence = _absence2.default;
exports.acceptance = _acceptance2.default;
exports.addValidator = _addValidator2.default;
exports.confirmation = _confirmation2.default;
exports.date = _date2.default;
exports.email = _email2.default;
exports.exclusion = _exclusion2.default;
exports.format = _format2.default;
exports.inclusion = _inclusion2.default;
exports.length = _length2.default;
exports.numericality = _numericality2.default;
exports.presence = _presence2.default;
exports.required = required;
exports.url = _url2.default;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var format = (0, _helpers.memoize)(function (_ref) {
  var wit = _ref['with'],
      without = _ref.without,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless,
      allowBlank = _ref.allowBlank;

  msg = (0, _helpers.toObjectMsg)(msg || message);

  return (0, _helpers.prepare)(ifCond, unless, allowBlank, function (value) {
    if (wit && !value.match(wit) || without && value.match(without)) {
      return _index2.default.formatMessage(msg || _messages2.default.invalid);
    }
  });
});

exports.default = format;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inclusionExclusion = inclusionExclusion;

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var inclusion = (0, _helpers.memoize)(function (options) {
  return inclusionExclusion(true, options);
});

exports.default = inclusion;
function inclusionExclusion(inclusion, _ref) {
  var inc = _ref['in'],
      within = _ref.within,
      caseSensitive = _ref.caseSensitive,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless,
      allowBlank = _ref.allowBlank;

  msg = (0, _helpers.toObjectMsg)(msg || message);
  within = [].concat(within || inc).map(function (val) {
    return '' + val;
  });

  return (0, _helpers.prepare)(ifCond, unless, allowBlank, function (value) {
    var cs = null != caseSensitive ? caseSensitive : _index2.default.defaultOptions.caseSensitive;
    var array = within;

    if (!cs) {
      value = value.toLowerCase();
      array = array.map(function (val) {
        return val.toLowerCase();
      });
    }
    if (inclusion) {
      if (array.indexOf(value) < 0) {
        return _index2.default.formatMessage(msg || _messages2.default.inclusion);
      }
    } else {
      if (array.indexOf(value) >= 0) {
        return _index2.default.formatMessage(msg || _messages2.default.exclusion);
      }
    }
  });
}

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var absence = (0, _helpers.memoize)(function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless;

  msg = (0, _helpers.toObjectMsg)(msg || message) || _messages2.default.absence;

  return (0, _helpers.prepare)(ifCond, unless, false, function (value) {
    if (value.trim()) {
      return _index2.default.formatMessage(msg);
    }
  });
});

exports.default = absence;

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defineMessages = defineMessages;
// This simply returns what's passed-in because it's meant to be a hook for
// babel-plugin-react-intl.
function defineMessages(messageDescriptors) {
  return messageDescriptors;
}

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var acceptance = (0, _helpers.memoize)(function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      accept = _ref.accept,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless;

  msg = (0, _helpers.toObjectMsg)(msg || message) || _messages2.default.acceptance;

  return (0, _helpers.prepare)(ifCond, unless, false, function (value) {
    if ([].concat(accept || _index2.default.defaultOptions.accept).map(String).indexOf(value) < 0) {
      return _index2.default.formatMessage(msg);
    }
  });
});

exports.default = acceptance;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = addValidator;

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function addValidator(_ref) {
  var validator = _ref.validator,
      defaultMessage = _ref.defaultMessage,
      defaultMsg = _ref.defaultMsg;

  defaultMsg = (0, _helpers.toObjectMsg)(defaultMsg || defaultMessage) || _messages2.default.invalid;

  return (0, _helpers.memoize)(function () {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var msg = (0, _helpers.toObjectMsg)(options.msg || options.message) || defaultMsg;

    return (0, _helpers.prepare)(options.if, options.unless, options.allowBlank, function (value, allValues) {
      var result = validator(options, value, allValues);
      if ('boolean' !== typeof result) {
        return result;
      }
      if (!result) {
        return _index2.default.formatMessage(msg);
      }
    });
  });
}

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var confirmation = (0, _helpers.memoize)(function (_ref) {
  var field = _ref.field,
      fieldLabel = _ref.fieldLabel,
      caseSensitive = _ref.caseSensitive,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless;

  msg = (0, _helpers.toObjectMsg)(msg || message);

  return (0, _helpers.prepare)(ifCond, unless, false, function (value, allValues) {
    var fieldValue = '' + (allValues[field] || '');
    var cs = null != caseSensitive ? caseSensitive : _index2.default.defaultOptions.caseSensitive;

    if (cs ? value !== fieldValue : value.toLowerCase() !== fieldValue.toLowerCase()) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.confirmation, { fieldLabel: fieldLabel || field }));
    }
  });
});

exports.default = confirmation;

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DATE_METHODS = {
  y: function y(d) {
    return d.getFullYear();
  },
  m: function m(d) {
    return d.getMonth() + 1;
  },
  d: function d(_d) {
    return _d.getDate();
  }
};

var PARSE_REG = /(y+|m+|d+)/g;

var TO_STRING = {}.toString;

var date = (0, _helpers.memoize)(function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      format = _ref.format,
      ymd = _ref.ymd,
      eq = _ref['='],
      diff = _ref['!='],
      gt = _ref['>'],
      gte = _ref['>='],
      lt = _ref['<'],
      lte = _ref['<='],
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless,
      allowBlank = _ref.allowBlank;

  msg = (0, _helpers.toObjectMsg)(msg || message);

  return (0, _helpers.prepare)(ifCond, unless, allowBlank, function (value) {
    var normFormat = normalizeFormat(format, ymd);
    var date = normParseDate(value, normFormat, false);
    if ('wrongFormat' === date) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.dateFormat, { format: format }));
    }
    if ('invalid' === date) {
      return _index2.default.formatMessage(msg || _messages2.default.dateInvalid);
    }
    if (date) {
      var date2 = void 0;
      if (eq && +date !== +(date2 = getDate(eq))) {
        return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.dateRange, values('=', date2, normFormat)));
      }
      if (diff && +date === +(date2 = getDate(diff))) {
        return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.dateRange, values('!=', date2, normFormat)));
      }
      if (gt && date <= (date2 = getDate(gt))) {
        return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.dateRange, values('>', date2, normFormat)));
      }
      if (gte && date < (date2 = getDate(gte))) {
        return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.dateRange, values('>=', date2, normFormat)));
      }
      if (lt && date >= (date2 = getDate(lt))) {
        return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.dateRange, values('<', date2, normFormat)));
      }
      if (lte && date > (date2 = getDate(lte))) {
        return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.dateRange, values('<=', date2, normFormat)));
      }
    }
  });
});

date.parseDate = parseDate;
date.formatDate = formatDate;

exports.default = date;


function parseDate(strDate, format, ymd) {
  return normParseDate(strDate, normalizeFormat(format, ymd), true);
}

function formatDate(date, format, ymd) {
  if (!(date instanceof Date) && '[object Date]' !== TO_STRING.call(date)) {
    return null;
  }
  var t = new Date(date).getTime();
  return t !== t ? null : normFormatDate(date, normalizeFormat(format, ymd));
}

function values(op, date, format) {
  return { op: op, date: normFormatDate(date, format), dateObject: date };
}

function getDate(d) {
  if ('function' === typeof d) {
    return new Date(+d());
  }
  if (isNaN(d) && 'today' === ('' + d).toLowerCase()) {
    var today = new Date();
    today.setHours(0, 0, 0, 0);
    return today;
  }
  return new Date(+d);
}

// FORMAT
function normFormatDate(date, format) {
  return format.replace(PARSE_REG, function (m) {
    var sym = m.charAt(0);
    var len = m.length;
    var padded = padding(DATE_METHODS[sym](date), len);
    return 'y' === sym ? padded.slice(padded.length - len, padded.length) : padded;
  });
}
function normalizeFormat(format, ymd) {
  var _reverseMapping;

  if (null == format) {
    format = _index2.default.defaultOptions.dateFormat;
  }
  if (!ymd) {
    ymd = _index2.default.defaultOptions.dateYmd;
  }
  if (!ymd || 'ymd' === ymd) {
    return format;
  }
  var reverseMapping = (_reverseMapping = {}, _defineProperty(_reverseMapping, ymd.charAt(0), 'y'), _defineProperty(_reverseMapping, ymd.charAt(1), 'm'), _defineProperty(_reverseMapping, ymd.charAt(2), 'd'), _reverseMapping);
  return format.replace(new RegExp('[' + ymd + ']', 'g'), function (sym) {
    return reverseMapping[sym];
  });
}
function padding(num, pad) {
  return '0'.repeat(Math.max(0, pad - ('' + num).length)) + num;
}

// PARSE
function normParseDate(value, format, parse) {
  var order = [];
  var reg = new RegExp('^' + format.replace(PARSE_REG, function (m) {
    order.push(m.charAt(0));
    return '([0-9]{' + m.length + '})';
  }) + '$');
  var match = value.match(reg);
  if (match) {
    var flags = {};
    order.forEach(function (token, index) {
      flags[token] = +match[index + 1];
    });
    var comparable = null != flags.y ? null != flags.m ? true : null == flags.d : false;
    flags = Object.assign({ y: 1970, m: 1, d: 1 }, flags);
    if (flags.y < 100) {
      flags.y = currentCentury(flags.y >= 69 ? -1 : 0) * 100 + flags.y;
    }
    var _date = new Date(flags.y, flags.m - 1, flags.d);
    return checkFlags(_date, flags) ? comparable || parse ? _date : null : parse ? new Date(NaN) : 'invalid';
  }
  return parse ? new Date(NaN) : 'wrongFormat';
}

function currentCentury(add) {
  var century = (0, _helpers.trunc)(new Date().getFullYear() / 100);
  return century < 0 ? century - add : century + add;
}

function checkFlags(date, flags) {
  var _ref2 = [date.getFullYear(), date.getMonth() + 1, date.getDate()],
      year = _ref2[0],
      month = _ref2[1],
      day = _ref2[2];

  return year === flags.y && month === flags.m && day === flags.d;
}

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var REG_EMAIL = /^[a-z0-9!#$%&\'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&\'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i;

// Uses "format" internally which is already memoized
var email = function email(options) {
  return (0, _helpers.regFormat)(Object.assign({}, options), REG_EMAIL, _messages2.default.email);
};

email.REG_EMAIL = REG_EMAIL;

exports.default = email;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _inclusion = __webpack_require__(4);

var _helpers = __webpack_require__(0);

var exclusion = (0, _helpers.memoize)(function (options) {
  return (0, _inclusion.inclusionExclusion)(false, options);
});

exports.default = exclusion;

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var length = (0, _helpers.memoize)(function (_ref) {
  var equal = _ref['='],
      is = _ref.is,
      max = _ref.max,
      maximum = _ref.maximum,
      min = _ref.min,
      minimum = _ref.minimum,
      range = _ref['in'],
      within = _ref.within,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless,
      allowBlank = _ref.allowBlank;

  msg = (0, _helpers.toObjectMsg)(msg || message);

  equal = (0, _helpers.isNumber)(equal) ? equal : is;
  min = (0, _helpers.isNumber)(min) ? min : minimum;
  max = (0, _helpers.isNumber)(max) ? max : maximum;
  range = range || within;
  if (range && (0, _helpers.isNumber)(range[0]) && (0, _helpers.isNumber)(range[1])) {
    min = range[0];
    max = range[1];
  }

  return (0, _helpers.prepare)(ifCond, unless, allowBlank, function (value) {
    if ((0, _helpers.isNumber)(equal) && value.length !== +equal) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.wrongLength, { count: equal }));
    }
    if ((0, _helpers.isNumber)(max) && value.length > +max) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.tooLong, { count: max }));
    }
    if ((0, _helpers.isNumber)(min) && value.length < +min) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.tooShort, { count: min }));
    }
  });
});

exports.default = length;

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var numericality = (0, _helpers.memoize)(function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      int = _ref.int,
      integer = _ref.integer,
      even = _ref.even,
      odd = _ref.odd,
      equal = _ref['='],
      equalTo = _ref.equalTo,
      diff = _ref['!='],
      otherThan = _ref.otherThan,
      greater = _ref['>'],
      greaterThan = _ref.greaterThan,
      less = _ref['<'],
      lessThan = _ref.lessThan,
      greaterOrEqual = _ref['>='],
      greaterThanOrEqualTo = _ref.greaterThanOrEqualTo,
      lessOrEqual = _ref['<='],
      lessThanOrEqualTo = _ref.lessThanOrEqualTo,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless,
      allowBlank = _ref.allowBlank;

  msg = (0, _helpers.toObjectMsg)(msg || message);

  int = int || integer;
  equal = (0, _helpers.isNumber)(equal) ? equal : equalTo;
  diff = (0, _helpers.isNumber)(diff) ? diff : otherThan;
  greater = (0, _helpers.isNumber)(greater) ? greater : greaterThan;
  less = (0, _helpers.isNumber)(less) ? less : lessThan;
  greaterOrEqual = (0, _helpers.isNumber)(greaterOrEqual) ? greaterOrEqual : greaterThanOrEqualTo;
  lessOrEqual = (0, _helpers.isNumber)(lessOrEqual) ? lessOrEqual : lessThanOrEqualTo;

  return (0, _helpers.prepare)(ifCond, unless, allowBlank, function (value) {
    if (!(0, _helpers.isNumber)(value)) {
      return _index2.default.formatMessage(msg || _messages2.default.notANumber);
    }
    if (int && +value % 1) {
      return _index2.default.formatMessage(msg || _messages2.default.notANumber);
    }
    if ((0, _helpers.isNumber)(equal) && +value !== +equal) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.equalTo, { count: equal }));
    }
    if ((0, _helpers.isNumber)(diff) && +value === +diff) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.otherThan, { count: diff }));
    }
    if ((0, _helpers.isNumber)(greater) && +value <= +greater) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.greaterThan, { count: greater }));
    }
    if ((0, _helpers.isNumber)(greaterOrEqual) && +value < +greaterOrEqual) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.greaterThanOrEqualTo, { count: greaterOrEqual }));
    }
    if ((0, _helpers.isNumber)(less) && +value >= +less) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.lessThan, { count: less }));
    }
    if ((0, _helpers.isNumber)(lessOrEqual) && +value > +lessOrEqual) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.lessThanOrEqualTo, { count: lessOrEqual }));
    }
    if (even && (0, _helpers.trunc)(+value) % 2) {
      return _index2.default.formatMessage(msg || _messages2.default.even);
    }
    if (odd && !((0, _helpers.trunc)(+value) % 2)) {
      return _index2.default.formatMessage(msg || _messages2.default.odd);
    }
  });
});

exports.default = numericality;

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var presence = (0, _helpers.memoize)(function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless;

  msg = (0, _helpers.toObjectMsg)(msg || message) || _messages2.default.presence;

  return (0, _helpers.prepare)(ifCond, unless, false, function (value) {
    if (!value.trim()) {
      return _index2.default.formatMessage(msg);
    }
  });
});

exports.default = presence;

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = __webpack_require__(1);

var _messages2 = _interopRequireDefault(_messages);

var _index = __webpack_require__(2);

var _index2 = _interopRequireDefault(_index);

var _helpers = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var REG_URL = /^(?:(?:(?:https?):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})).?)(?::\d{2,5})?(?:[/?#]\S*)?$/i;

// Uses "format" internally which is already memoized
var url = function url(options) {
  options = Object.assign({}, options);
  var reg = REG_URL;
  var protocols = options.protocols || options.protocol || _index2.default.defaultOptions.urlProtocols;
  if (protocols) {
    protocols = [].concat(protocols).join('|');
    if (protocols !== 'http|https') {
      reg = new RegExp(REG_URL.source.replace('https?', protocols), REG_URL.flags);
    }
  }
  return (0, _helpers.regFormat)(options, reg, _messages2.default.url);
};

url.REG_URL = REG_URL;

exports.default = url;

/***/ })
/******/ ]);
});