'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = require('./messages');

var _messages2 = _interopRequireDefault(_messages);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var confirmation = (0, _helpers.memoize)(function (_ref) {
  var field = _ref.field,
      fieldLabel = _ref.fieldLabel,
      caseSensitive = _ref.caseSensitive,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless;

  msg = (0, _helpers.toObjectMsg)(msg || message);

  return (0, _helpers.prepare)(ifCond, unless, false, function (value, allValues) {
    var fieldValue = '' + (allValues[field] || '');
    var cs = null != caseSensitive ? caseSensitive : _index2.default.defaultOptions.caseSensitive;

    if (cs ? value !== fieldValue : value.toLowerCase() !== fieldValue.toLowerCase()) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.confirmation, { fieldLabel: fieldLabel || field }));
    }
  });
});

exports.default = confirmation;