'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = require('./messages');

var _messages2 = _interopRequireDefault(_messages);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var length = (0, _helpers.memoize)(function (_ref) {
  var equal = _ref['='],
      is = _ref.is,
      max = _ref.max,
      maximum = _ref.maximum,
      min = _ref.min,
      minimum = _ref.minimum,
      range = _ref['in'],
      within = _ref.within,
      message = _ref.message,
      msg = _ref.msg,
      ifCond = _ref['if'],
      unless = _ref.unless,
      allowBlank = _ref.allowBlank;

  msg = (0, _helpers.toObjectMsg)(msg || message);

  equal = (0, _helpers.isNumber)(equal) ? equal : is;
  min = (0, _helpers.isNumber)(min) ? min : minimum;
  max = (0, _helpers.isNumber)(max) ? max : maximum;
  range = range || within;
  if (range && (0, _helpers.isNumber)(range[0]) && (0, _helpers.isNumber)(range[1])) {
    min = range[0];
    max = range[1];
  }

  return (0, _helpers.prepare)(ifCond, unless, allowBlank, function (value) {
    if ((0, _helpers.isNumber)(equal) && value.length !== +equal) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.wrongLength, { count: equal }));
    }
    if ((0, _helpers.isNumber)(max) && value.length > +max) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.tooLong, { count: max }));
    }
    if ((0, _helpers.isNumber)(min) && value.length < +min) {
      return _index2.default.formatMessage(msg || (0, _helpers.addMsgValues)(_messages2.default.tooShort, { count: min }));
    }
  });
});

exports.default = length;